# chart-live-stock-data

> Real-time Candlestick chart streaming live AAPL OHLC ticks with crosshair and last-value label.

**Framework:** javascript  **Component:** Chart  **Variant:** live-stock-data

## Get this item

**If you are an agent, fetch the JSON.** Source is inlined, so one request is enough and no tooling is required:

```
GET https://ai.syncfusion.com/r/javascript/chart-live-stock-data.json
```

**Install Package(s)**

```bash
npm install @syncfusion/ej2-charts
```

**Notes**

- Syncfusion release: 2026 Volume 2 (v34.1.29)
- The Syncfusion package is licensed. The composition in this file is source you own and edit. See https://ai.syncfusion.com/licensing.md

## Source files

### src/components/chart-live-stock-data/live-stock-data.html

```html
<div class="control-section">
    <div id="stock" align="center"></div>
</div>

<style>
    #control-container {
        padding: 0px !important;
    }
</style>
```

### src/components/chart-live-stock-data/live-stock-data.ts

```typescript
import { Chart, CandleSeries, DateTime, Crosshair, ChartAnnotation, type ILoadedEventArgs, type IAxisRangeCalculatedEventArgs } from '@syncfusion/ej2-charts';
import { LastValueLabel } from '@syncfusion/ej2-charts';
Chart.Inject(CandleSeries, DateTime, Crosshair, ChartAnnotation, LastValueLabel);
import { Browser } from '@syncfusion/ej2-base';
import { loadChartTheme } from '../theme-color';

/**
 * Sample of candle updates for a few seconds.
 */
let value: number = 180;
let intervalId: ReturnType<typeof setTimeout> | number| null;
let getData = (): { series: Candlestick[] } => {
    let series: Candlestick[] = [];
    let point: Candlestick;
    for (let i: number = 0; i < 30; i++) {
        value = 180 + (Math.random() * 25) * Math.sin(i * Math.PI / 8);
        value = Math.max(140, Math.min(260, value));
        if (value > 260) {
            value = 260;
        }
        if (value < 140) {
            value = 140;
        }
        value += Math.random() * 0.1;
        let open: number = value + Math.round(Math.random() * 18);
        let low: number = Math.min(value, open) - Math.round(Math.random() * 6);
        let high: number = Math.min(220, Math.max(value, open) + Math.round(Math.random() * 15));
        point = {
            x: new Date(2000, 5, 2, 2, 0, i),
            close: value,
            open: open,
            low: low,
            high: high
        };
        series.push(point);
    }
    return { series: series };
};

let data: Candlestick[] = getData().series;
let incVal: number = 0;
let updateVal: number = data.length;

(window as any).default = (): void => {
    let chart: Chart = new Chart({
        //Initializing Primary X and Y Axis
        primaryXAxis: {
            valueType: 'DateTime', interval: Browser.isDevice ? 8 : 4, crosshairTooltip: { enable: true }, edgeLabelPlacement: Browser.isDevice ? 'None' : 'Shift', majorGridLines: { width: 0 }, labelIntersectAction: 'Hide'
        },
        chartArea: { border: { width: 0 } },
        primaryYAxis:
        {
            interval: 20, opposedPosition: true, minimum: 120, crosshairTooltip: { enable: true }, lineStyle: { width: 0 },
            majorGridLines: { width: 1 }, majorTickLines: { width: 0 }
        },
        //Initializing Chart Series
        series: [
            {
                type: 'Candle', bearFillColor: '#2ecd71', bullFillColor: '#e74c3d', columnWidth: 0.4,
                dataSource: data, xName: 'x', low: 'low', high: 'high', open: 'open', close: 'close', lastValueLabel: { enable: true, background: 'red', dashArray: '3,2', lineWidth: 0.5, font: {size: '10px'} }
            }
        ],
        width: Browser.isDevice ? '100%' : '90%',
        title: 'AAPL Historical',
        crosshair: { enable: true, dashArray: '5,5' },
        pointRender: function (args) {
            args.series.lastValueLabel.background = args.fill;
        },
        load: (args: ILoadedEventArgs) => {
            loadChartTheme(args);
            stockClearInterval();
            intervalId = setInterval(function () {
                let container = document.getElementById('stock');
                if (container && container.id === args.chart.element.id) {
                    let newData1: Candlestick[] = [];
                    let value: number = 180;
                    for (let i: number = 0; i < data.length; i++) {
                        newData1.push(Object.assign({}, data[i]));
                    }
                    if (newData1.length > 0) {
                        const lastIndex: number = newData1.length - 1;
                        const previousClose: number = newData1[lastIndex].close;
                        newData1[lastIndex].close += (Math.random() < 0.5 ? 1 : -1) * Math.random() * 25;
                        newData1[lastIndex].close = Math.min(Math.min(Math.max(newData1[lastIndex].close, newData1[lastIndex].low + 5), newData1[lastIndex].high - 5), newData1[lastIndex].open - 2);
                        if (previousClose === newData1[lastIndex].close) {
                            newData1[lastIndex].close -= 5;
                        }
                    }
                    if (incVal < 10) {
                        if (chart.series.length > 0) {
                            chart.series[0].setData!(newData1);
                            incVal++;
                        }
                    }
                    else {
                        let change: number = (Math.random() < 0.49 ? 1 : -1) * Math.random() * 10;
                        value += change;
                        if (value > 260) {
                            value = 260;
                        }
                        if (value < 140) {
                            value = 140;
                        }
                        value += Math.random() * 0.1;
                        let open: number = value + Math.round(Math.random() * 12);
                        let low: number = Math.min(value, open) - Math.round(Math.random() * 8);
                        let high: number = Math.max(value, open) + Math.round(Math.random() * 15);
                        if (chart.series.length > 0) {
                            let lastDataPointIndex = data.length - 1;
                            if (lastDataPointIndex >= 0) {
                                let timestamp = (chart.series[0].dataSource as { x: unknown }[])[lastDataPointIndex].x as number;
                                let lastTimestamp = new Date(timestamp).getTime();
                                chart.series[0].addPoint!({ x: new Date(lastTimestamp + 1000), high: high, low: low, open: open, close: value });
                            }
                        }
                        incVal = 0;
                        updateVal++;
                    }
                }
                else {
                    stockClearInterval();
                }
            }, 1000);
        },
        axisRangeCalculated: (args: IAxisRangeCalculatedEventArgs) => {
            if (args.axis.name === 'primaryXAxis') {
                let lastPoint: Object = args.axis.series[0].points[args.axis.series[0].points.length - 1].x;
                args.maximum = new Date(Number(lastPoint)).getTime() + 2500;
                let firstPoint: Object = args.axis.series[0].points[0].x;
                args.minimum = new Date(Number(firstPoint)).getTime() + 500;
            }
        }
    });
    chart.appendTo('#stock');
    function stockClearInterval() {
        if (intervalId) {
            clearInterval(intervalId);
            intervalId = null;
        }
    }
};
interface Candlestick {
    open: number;
    close: number;
    high: number;
    low: number;
    x: Date;
}
```


# chart-live-stock-data

> Chart streams changing AAPL stock prices with a live-updating candle series.

**Framework:** vue  **Component:** Chart  **Variant:** live-stock-data

## Get this item

**If you are an agent, fetch the JSON.** Source is inlined, so one request is enough and no tooling is required:

```
GET https://ai.syncfusion.com/r/vue/chart-live-stock-data.json
```

**Install Package(s)**

```bash
npm install @syncfusion/ej2-vue-charts
```

**Notes**

- Syncfusion release: 2026 Volume 2 (v34.1.29)
- The Syncfusion package is licensed. The composition in this file is source you own and edit. See https://ai.syncfusion.com/licensing.md

## Source files

### src/components/chart-live-stock-data/Chart.vue

```vue
<template>
  <div class="control-section">
    <div align='center'>
        <ejs-chart ref="chart" style='display:block' :load='load' :axisRangeCalculated='axisRangeCalculated' :pointRender='pointRender' align='center' id='stock' :title='title' :primaryXAxis='primaryXAxis' :primaryYAxis='primaryYAxis'
            :chartArea='chartArea' :width='width' :crosshair='crosshair'>
            <e-series-collection>
                <e-series :dataSource='seriesData1' type='Candle' :lastValueLabel='lastValueLabel' bearFillColor='#2ecd71' bullFillColor='#e74c3d' columnWidth=0.4
                xName='x' low='low' high='high' open='open' close='close'> </e-series>
            </e-series-collection>
        </ejs-chart>
    </div>
  </div>
</template>

<script>
import { Browser } from '@syncfusion/ej2-base';
import { ChartComponent, SeriesDirective, SeriesCollectionDirective, AnnotationDirective, AnnotationsDirective, CandleSeries, DateTime, Crosshair, ChartAnnotation, LastValueLabel } from "@syncfusion/ej2-vue-charts";

let value = 180;
let getData = () => {
    let series = [];
    let point;
    for (let i = 0; i < 30; i++) {
        value = 180 + ((Math.random() * 25) * Math.sin(i * Math.PI / 8)); // Adjust the function as needed
        value = Math.max(140, Math.min(260, value));
        if (value > 260) {
            value = 260;
        }
        if (value < 140) {
            value = 140;
        }
        value += Math.random() * 0.1;
        let open = value + Math.round(Math.random() * 18);
        let low = Math.min(value, open) - Math.round(Math.random() * 6);
        let high = Math.min(220, Math.max(value, open) + Math.round(Math.random() * 15));
        point = {
            x: new Date(2000, 5, 2, 2, 0, i),
            close: value,
            open: open,
            low: low,
            high: high
        };
        series.push(point);
    }
    return { series: series };
};

let data = getData().series;
let incVal = 0;
let updateVal = data.length;
let pointAdded = false;

export default {
  components: {
    'ejs-chart': ChartComponent,
    'e-series-collection': SeriesCollectionDirective,
    'e-series': SeriesDirective,
    'e-annotations': AnnotationsDirective,
    'e-annotation': AnnotationDirective
  },
  data: function() {
    return {
        seriesData1: data,
        lastValueLabel: { enable: true, background: 'red', dashArray: '3,2', lineWidth: 0.5, font: {size: '10px'} },
        //Initializing Primary X Axis
        primaryXAxis: {
            valueType: 'DateTime', 
            interval: Browser.isDevice ? 8 : 4,
            crosshairTooltip: { enable: true }, 
            edgeLabelPlacement: Browser.isDevice ? 'None' : 'Shift', 
            majorGridLines: { width: 0 },
            labelIntersectAction: 'Hide'
        },
        //Initializing Primary Y Axis
        primaryYAxis:
        { 
            interval: 20, 
            opposedPosition: true, 
            minimum: 120,
            crosshairTooltip: { enable: true }, 
            lineStyle: { width: 0 }, 
            majorGridLines: { width: 1 }, 
            majorTickLines: { width: 0 }
        },
        chartArea: {
            border: {
                width: 0
            }
        },
        width : Browser.isDevice ? '100%' : '90%',
        title: "AAPL Historical",
        crosshair: { 
            enable: true, 
            dashArray: '5,5' 
        },
    };
  },
  provide: {
    chart: [CandleSeries, DateTime, Crosshair, ChartAnnotation, LastValueLabel]
  },
  methods: {
      load: function (args) {
          this.clearInterval();
          this.intervalId = setInterval(() => {
              var container = document.getElementById('stock');
              if (container && container.id === args.chart.element.id) {
                  let newData1 = [];
                  let value = 180;
                  pointAdded = true;
                  for (let i = 0; i < args.chart.series[0].dataSource.length; i++) {
                      newData1.push(Object.assign({}, args.chart.series[0].dataSource[i]));
                  }
                  if (newData1.length > 0) {
                      let lastIndex = newData1.length - 1;
                      let previousClose = newData1[lastIndex].close;
                      newData1[lastIndex].close += (Math.random() < 0.5 ? 1 : -1) * Math.random() * 25;
                      newData1[lastIndex].close = Math.min(Math.min(Math.max(newData1[lastIndex].close, newData1[lastIndex].low + 5), newData1[lastIndex].high - 5), newData1[lastIndex].open - 2);
                      if (previousClose === newData1[lastIndex].close) {
                          newData1[lastIndex].close -= 5;
                      }
                  }
                  if (incVal < 10) {
                      if (args.chart.series.length > 0) {
                          args.chart.series[0].setData(newData1);
                          incVal++;
                      }
                  }
                  else {
                      let change = (Math.random() < 0.49 ? 1 : -1) * Math.random() * 10;
                      value += change;
                      if (value > 260) {
                          value = 260;
                      }
                      if (value < 140) {
                          value = 140;
                      }
                      value += Math.random() * 0.1;
                      let open = value + Math.round(Math.random() * 12);
                      let low = Math.min(value, open) - Math.round(Math.random() * 8);
                      let high = Math.max(value, open) + Math.round(Math.random() * 15);
                      if (args.chart.series.length > 0) {
                          var lastDataPointIndex = args.chart.series[0].dataSource.length - 1;
                          if (lastDataPointIndex >= 0) {
                              var timestamp = args.chart.series[0].dataSource[lastDataPointIndex].x;
                              var lastTimestamp = new Date(timestamp).getTime();
                              args.chart.series[0].addPoint({ x: new Date(lastTimestamp + 1000), high: high, low: low, open: open, close: value });
                          }
                      }
                      incVal = 0;
                      updateVal++;
                  }
              }
              else {
                  this.clearInterval();
              }
          }, 1000);
      },
      clearInterval() {
          if (this.intervalId) {
              clearInterval(this.intervalId);
              this.intervalId = null;
          }
      },
    axisRangeCalculated: function(args) {
        if (args.axis.name === 'primaryXAxis') {
            let lastPoint = args.axis.series[0].points[args.axis.series[0].points.length - 1].x;
            args.maximum = new Date(lastPoint).getTime() + 2500;
            let firstPoint = args.axis.series[0].points[0].x;
            args.minimum = new Date(firstPoint).getTime() + 500;
        }
    },
    pointRender: function(args) {
        args.series.lastValueLabel.background = args.fill;
    }
  }
};
</script>
```

### src/components/chart-live-stock-data/ChartView.vue

```vue
<template>
  <Chart />
</template>

<script setup>
import Chart from '../../components/Chart.vue'
</script>
```


# chart-live-stock-data

> Real-time Candlestick chart streaming live AAPL OHLC ticks with crosshair and last-value label.

**Framework:** angular  **Component:** Chart  **Variant:** live-stock-data

## Get this item

**If you are an agent, fetch the JSON.** Source is inlined, so one request is enough and no tooling is required:

```
GET https://ai.syncfusion.com/r/angular/chart-live-stock-data.json
```

**Install Package(s)**

```bash
npm install @syncfusion/ej2-angular-charts
```

**Notes**

- Syncfusion release: 2026 Volume 2 (v34.1.29)
- The Syncfusion package is licensed. The composition in this file is source you own and edit. See https://ai.syncfusion.com/licensing.md

## Source files

### src/components/chart-live-stock-data/live-stock-data.component.ts

```typescript
import { Component, OnDestroy, ViewEncapsulation } from '@angular/core';
import { ILoadedEventArgs, IAxisRangeCalculatedEventArgs, LastValueLabel, ChartTheme, ChartAllModule, Series } from '@syncfusion/ej2-angular-charts';
import { Browser } from '@syncfusion/ej2-base';
import { loadChartTheme } from '../theme-color';
/**
 * Sample for Spline Series
 */
@Component({
    selector: 'control-content',
    templateUrl: 'live-stock-data.html',
    encapsulation: ViewEncapsulation.None,
    standalone: true,
    imports: [ ChartAllModule]
})
export class LiveStockDataComponent implements OnDestroy {
    public chartArea: Object = {
        border: {
            width: 0
        }
    };
    public width: string = Browser.isDevice ? '100%' : '90%';
    //Initializing Primary X Axis
    public primaryXAxis: Object = {
        valueType: 'DateTime', 
        interval: Browser.isDevice ? 8 : 4, 
        crosshairTooltip: { enable: true }, 
        edgeLabelPlacement: Browser.isDevice ? 'None' : 'Shift',
        majorGridLines: { width: 0 },
        labelIntersectAction: 'Hide'
    };
    //Initializing Primary Y Axis
    public primaryYAxis: Object = {
        interval: 20, 
        opposedPosition: true, 
        minimum: 120, 
        crosshairTooltip: { enable: true }, 
        lineStyle: { width: 0 },
        majorGridLines: { width: 1 }, 
        majorTickLines: { width: 0 }
    };
    public lastValueLabel: Object = { enable: true, background: 'red', dashArray: '3,2', lineWidth: 0.5, font: {size: '10px'} };
    public getData = (): { series: Candlestick[] } => {
        let value: number = 180;
        let series: Candlestick[] = [];
        let point: Candlestick;
        for (let i: number = 0; i < 30; i++) {
        value = 180 + (Math.random() * 25) * Math.sin(i * Math.PI / 8); // Adjust the function as needed
        value = Math.max(140, Math.min(260, value));
        if (value > 260) {
            value = 260;
        }
        if (value < 140) {
            value = 140;
        }
        value += Math.random() * 0.1;
            let open: number = value + Math.round(Math.random() * 18);
            let low: number = Math.min(value, open) - Math.round(Math.random() * 6);
            let high: number = Math.min(220, Math.max(value, open) + Math.round(Math.random() * 15));
            point = {
                x: new Date(2000, 5, 2, 2, 0, i),
                close: value,
                open: open,
                low: low,
                high: high
            };
            series.push(point);
        }
        return { series: series };
    };
    public data: Candlestick[] = this.getData().series;
    public updateVal: number = this.data.length;
    public incVal: number = 0;
    public pointAdded: boolean = false;
    private intervalId: any;
    public load(args: ILoadedEventArgs): void {
        loadChartTheme(args);
        const chart: LiveStockDataComponent = this;
        this.clearInterval(); // Clear any existing interval
        this.intervalId = setInterval(function () {
            var container = document.getElementById('stock');
            if (container && container.id === args.chart.element.id) {
                let newData1: Candlestick[] = [];
                let value: number = 180;
                chart.pointAdded = true;
                const dataSource : Candlestick[] = args.chart.series[0].dataSource as Candlestick[];
                for (let i: number = 0; i < dataSource.length; i++) {
                    newData1.push(Object.assign({}, dataSource[i]));
                }
                if (newData1.length > 0) {
                    const lastIndex: number = newData1.length - 1;
                    const previousClose: number = newData1[lastIndex].close;
                    newData1[lastIndex].close += (Math.random() < 0.5 ? 1 : -1) * Math.random() * 25;
                    newData1[lastIndex].close = Math.min(Math.min(Math.max(newData1[lastIndex].close, newData1[lastIndex].low + 5), newData1[lastIndex].high - 5), newData1[lastIndex].open - 2);
                    if (previousClose === newData1[lastIndex].close) {
                        newData1[lastIndex].close -= 5;
                    }
                }
                if (chart.incVal < 10) {
                    if (args.chart.series.length > 0) {
                        args.chart.series[0]!.setData!(newData1);
                        chart.incVal++;
                    }
                }
                else {
                    let change: number = (Math.random() < 0.49 ? 1 : -1) * Math.random() * 10;
                    value += change;
                    if (value > 260) {
                        value = 260;
                    }
                    if (value < 140) {
                        value = 140;
                    }
                    value += Math.random() * 0.1;
                    let open: number = value + Math.round(Math.random() * 12);
                    let low: number = Math.min(value, open) - Math.round(Math.random() * 8);
                    let high: number = Math.max(value, open) + Math.round(Math.random() * 15);
                    if (args.chart.series.length > 0) {
                        const dataSource = args.chart.series[0]!.dataSource as Candlestick[];
                        var lastDataPointIndex = dataSource.length - 1;
                        if (lastDataPointIndex >= 0) {
                            var timestamp = dataSource[lastDataPointIndex].x;
                            var lastTimestamp = new Date(timestamp).getTime();
                            args.chart.series[0]!.addPoint!({ x: new Date(lastTimestamp + 1000), high: high, low: low, open: open, close: value });
                        }
                    }
                    chart.incVal = 0;
                    chart.updateVal++;
                }
            } else {
                chart.clearInterval();
            }
        }, 1000);
    };

    private clearInterval(): void {
        if (this.intervalId) {
            clearInterval(this.intervalId);
            this.intervalId = null;
        }
    }
 
    public axisRangeCalculated (args: IAxisRangeCalculatedEventArgs): void {
        if (args.axis.name === 'primaryXAxis') {
            let lastPoint: Object = args.axis.series[0].points[args.axis.series[0].points.length - 1].x;
            args.maximum = new Date(Number(lastPoint)).getTime() + 2500;
            let firstPoint: Object = args.axis.series[0].points[0].x;
            args.minimum = new Date(Number(firstPoint)).getTime() + 500;
        }
    }
    public pointRender (args: any): void {
        args.series.lastValueLabel.background = args.fill;
    };
    public title: string = 'AAPL Historical';
    public crosshair: Object = { enable: true, dashArray: '5,5' };
    constructor() {
        //code
    };
    ngOnDestroy(): void {
        this.clearInterval();
    }
}
interface Candlestick {
    open: number;
    close: number;
    high: number;
    low: number;
    x: Date;
}
```

### src/components/chart-live-stock-data/live-stock-data.html

```html

<div class="control-section">
    <div align='center'>
        <ejs-chart id='stock' align='center' [chartArea]='chartArea' [width]='width' style='display:block;' [primaryXAxis]='primaryXAxis'
            [primaryYAxis]='primaryYAxis' (load)='load($event)' (pointRender)='pointRender($event)' (axisRangeCalculated)='axisRangeCalculated($event)' 
            [title]='title' [crosshair]='crosshair'>
            <e-series-collection>
                <e-series [dataSource]='data' type='Candle' xName='x' low='low' high='high' open='open' close='close' columnWidth=0.4 bearFillColor='#2ecd71' bullFillColor='#e74c3d' [lastValueLabel]='lastValueLabel'> </e-series>
            </e-series-collection>
        </ejs-chart>
    </div>
</div>

<style>
    #control-container {
        padding: 0px !important;
    }
</style>
```
